package io.gitlab.jfronny.inceptum.common;

import io.gitlab.jfronny.gson.stream.JsonReader;
import io.gitlab.jfronny.gson.stream.JsonWriter;

public class GsonPreset {
    public static class Config {
        public static void configure(JsonReader reader) {
            reader.isSerializeSpecialFloatingPointValues = true;
            reader.isLenient = true;
        }

        public static void configure(JsonWriter writer) {
            writer.serializeNulls = true;
            writer.isSerializeSpecialFloatingPointValues = true;
            writer.isLenient = true;
            writer.indent = "    ";
            writer.omitQuotes = true;
        }
    }

    public static class Api {
        public static void configure(JsonReader reader) {
            reader.isSerializeSpecialFloatingPointValues = true;
            reader.isLenient = true;
        }

        public static void configure(JsonWriter writer) {
            writer.serializeNulls = false;
            writer.isSerializeSpecialFloatingPointValues = true;
            writer.isLenient = false;
        }
    }
}
