plugins {
    id("inceptum.application-standalone")
}

application {
    mainClass.set("io.gitlab.jfronny.inceptum.Inceptum")
}

dependencies {
    implementation(project(":launcher"))
    implementation(project(":launcher-cli"))
    implementation(project(":launcher-imgui"))
}

tasks.shadowJar {
    archiveClassifier.set(rootProject.extra["flavorProp"] as String)
    archiveBaseName.set("Inceptum")
    exclude("about.html")
    exclude("plugin.properties")
    exclude("META-INF/**")
}

(components["java"] as AdhocComponentWithVariants).withVariantsFromConfiguration(configurations["shadowRuntimeElements"]) {
    skip()
}

publishing {
    publications {
        create<MavenPublication>("mavenJava") {
            from(components["java"])
        }
    }
}