package io.gitlab.jfronny.inceptum.gtk.window;

import io.gitlab.jfronny.inceptum.gtk.GtkMain;
import org.gtk.gtk.AboutDialog;
import org.gtk.gtk.License;
import io.gitlab.jfronny.inceptum.common.BuildMetadata;
import io.gitlab.jfronny.inceptum.gtk.util.I18n;

public class AboutWindow extends AboutDialog {
    public AboutWindow() {
        programName = "Inceptum";
        copyright = "Copyright (C) 2021-2023 JFronny";
        version = BuildMetadata.VERSION;
        licenseType = License.MIT_X11;
        license = I18n.get("about.license");
        websiteLabel = I18n.get("about.contact");
        website = "https://jfronny.gitlab.io/contact.html";
        if (!BuildMetadata.IS_PUBLIC) {
            comments = I18n.get("about.unsupported-build");
        }
        int vm = Runtime.version().feature();
        systemInformation = I18n.get(BuildMetadata.VM_VERSION == vm ? "about.jvm" : "about.jvm.unsupported", vm);
        //TODO setLogo
    }

    public static void createAndShow() {
        new AboutWindow().show();
    }
}
