package io.gitlab.jfronny.inceptum.launcher.model.fabric;

import io.gitlab.jfronny.gson.compile.annotations.GSerializable;
import io.gitlab.jfronny.inceptum.common.GsonPreset;

import java.util.List;

@GSerializable(configure = GsonPreset.Api.class)
public class FabricVersionLoaderInfo {
    public FabricLoaderVersion loader;
    public IntermediaryVersion intermediary;

    @GSerializable(configure = GsonPreset.Api.class)
    public static class WithMeta extends FabricVersionLoaderInfo {
        public LauncherMeta launcherMeta;

        @GSerializable(configure = GsonPreset.Api.class)
        public record LauncherMeta(int version, Libraries libraries, MainClass mainClass) {
            @GSerializable(configure = GsonPreset.Api.class)
            public record Libraries(List<Library> client, List<Library> common, List<Library> server) {
                @GSerializable(configure = GsonPreset.Api.class)
                public record Library(String name, String url) {
                }
            }

            @GSerializable(configure = GsonPreset.Api.class)
            public record MainClass(String client, String server) {
            }
        }
    }
}
