package io.gitlab.jfronny.inceptum.launcher.model.mojang;

import io.gitlab.jfronny.gson.annotations.SerializedName;
import io.gitlab.jfronny.gson.compile.annotations.GSerializable;
import io.gitlab.jfronny.inceptum.common.GsonPreset;

import java.util.List;
import java.util.Map;

@GSerializable(configure = GsonPreset.Api.class)
public record JvmInfo(Map<String, List<Jvm>> linux,
                      @SerializedName("mac-os") Map<String, List<Jvm>> macOs,
                      @SerializedName("windows-x64") Map<String, List<Jvm>> windowsX64) {
    @GSerializable(configure = GsonPreset.Api.class)
    public record Jvm(Availability availability, MojangFileDownload manifest, Version version) {
        @GSerializable(configure = GsonPreset.Api.class)
        public record Availability(int group, int progress) {
        }

        @GSerializable(configure = GsonPreset.Api.class)
        public record Version(String name, String released) {
        }
    }
}
