package io.gitlab.jfronny.inceptum.launcher.system.mds.noop;

import io.gitlab.jfronny.inceptum.launcher.system.instance.Mod;
import io.gitlab.jfronny.inceptum.launcher.system.mds.ModsDirScanner;

import java.io.IOException;
import java.nio.file.Path;
import java.util.Set;
import java.util.function.BiConsumer;

public record NoopMds(String gameVersion) implements ModsDirScanner {
    @Override
    public void close() throws IOException {
    }

    @Override
    public boolean isComplete() {
        return true;
    }

    @Override
    public void start() {
    }

    @Override
    public String getGameVersion() {
        return gameVersion;
    }

    @Override
    public Set<Mod> getMods() throws IOException {
        return Set.of();
    }

    @Override
    public Mod get(Path path) {
        return new NoopMod(path);
    }

    @Override
    public void invalidate(Path path) {
    }

    @Override
    public boolean hasScanned(Path path) {
        return true;
    }

    @Override
    public void runOnce(BiConsumer<Path, Mod> discovered) {
    }
}
